#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Feb 15 09:39:16 2019

@author: stan
"""
from random import randint
from boolparse.logic.truth_table import TruthTable
from rb.red_booleana import RedBooleana
from random import sample
class NKRedBooleana(RedBooleana):
    
    def __init__(self,N,K):
        self.N = N
        self.K = K
        self.variables = ['x'+str(i) for i in range(1,N+1)]
        self.create_random_tables()
        super().__init__(vertices=self.variables,
                         aristas=None,
                         reglas=None,
                         tablas=self.tables)
        
    def create_random_tables(self):
        self.tables = {
                v:
                TruthTable(
                sorted(sample(self.variables,self.K)),
                v,
                [randint(0,1)==1 for i in range(2**self.K)])
                for v in self.variables}
        