#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue May  7 08:45:26 2019

@author: stan
"""
from formula_parser import FormulaParser as parser
from cnf import CNF
from pysat.solvers import Glucose3
class DubrovaTeslenko:
    
    def __init__(self,net):
        self.net = net
        self.solver = None
        
    def rename(self,var,t):
        return var + "___" + str(t)
        
    def unfolding_formula(self,start,end=0):
        T = []
        for t in range(start,end):
            net = self.net
            nodes = net.vertices
            for table in net.tablas:
                formula = table.formulastr
                for var in sorted(nodes,key=len,reverse=True):
                    formula = formula.replace(var,self.rename(var,t+1))
                T = T.append(
                    '(' + self.rename(table.name,t) + '=' + formula +')')
            return T.join("&")
        
    def Sat(self,F):
        ##instancia del SAT sover
        self.solver = Glucose3()
        self.solver = solver
        formula,variables = parser.parse(F)
        converter = CNF(formula,variables)
        self.converter = converter
        f_equisatisfactible = converter.convert()
        print(f_equisatisfactible)
        for clause in converter.dimacs:
            solver.add_clause(clause)
        return solver.enum_models()
            
        
    def compute_attractors(self):
        i = min(n,100)
        attractor_is_found = False
        A = set()
        F = self.unfolding_formula(i)
        for model in Sat(F):
            #asignación
            a = {self.converter.decode[abs(i)]:i>0 for i in model} 
            
